/**
 * <!--------------------------------------------------------------------------
 * This file is part of libSBMLSim.  Please visit
 * http://fun.bio.keio.ac.jp/software/libsbmlsim/ for more
 * information about libSBMLSim and its latest version.
 *
 * Copyright (C) 2011-2017 by the Keio University, Yokohama, Japan
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation.  A copy of the license agreement is provided
 * in the file named "LICENSE.txt" included with this software distribution.
 * ---------------------------------------------------------------------- -->*/
/*
 **  GETOPT PROGRAM AND LIBRARY ROUTINE
 **
 **  I wrote main() and AT&T wrote getopt() and we both put our efforts into
 **  the public domain via mod.sources.
 **	Rich $alz
 **	Mirror Systems
 **	(mirror!rs, rs@mirror.TMC.COM)
 **	August 10, 1986
 ** 
 **  This is the public-domain AT&T getopt(3) code.  Hacked by Rich and by Jim.
 */

#define ERR(_s, _c) { if (opterr) fprintf (stderr, "%s%s%c\n", argv[0], _s, _c);}

int	opterr = 1;
int	optind = 1;
int	optopt;
char	*optarg;

int getopt(int argc, char **argv, char *opts)
{
  static int sp = 1;
  register int c;
  register char *cp;

  if(sp == 1) {
    if(optind >= argc || argv[optind][0] != '-' || argv[optind][1] == '\0') {
      return(EOF);
    } else { 
      if(strcmp(argv[optind], "--") == 0) {
        optind++;
        return(EOF);
      }
    }
  }
  optopt = c = argv[optind][sp];
  if(c == ':' || (cp=strchr(opts, c)) == NULL) {
    ERR(": illegal option -- ", c);
    if(argv[optind][++sp] == '\0') {
      optind++;
      sp = 1;
    }
    return('?');
  }
  if(*++cp == ':') {
    if(argv[optind][sp+1] != '\0') {
      optarg = &argv[optind++][sp+1];
    } else if(++optind >= argc) {
      ERR(": option requires an argument -- ", c);
      sp = 1;
      return('?');
    } else {
      optarg = argv[optind++];
    }
    sp = 1;
  } else {
    if(argv[optind][++sp] == '\0') {
      sp = 1;
      optind++;
    }
    optarg = NULL;
  }
  return(c);
}
